﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PositionOfRowFromCurreentCell
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            DataTable srcTable = this.GetTable();
            // set datasource for the GridGroupingControl
            this.gridGroupingControl1.DataSource = srcTable;
            //Event triggering for CurrentCellClicl event.
            this.gridGroupingControl1.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
        }

void gridGroupingControl1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
{
    try
    {
        Table table = e.TableControl.Table;

        // Gets the current display element.
        Element el = table.DisplayElements[e.Inner.RowIndex];

        // Gets the current record.
        Record r = el.ParentRecord;
                
        //Finds its row position.
        int dataRowPos = table.UnsortedRecords.IndexOf(r);

        //Retrieves the corresponding data row from the datasource.
        DataRow dr = dt.Rows[dataRowPos];
                
        //Accesses the CutomerId value of the current record.
        this.textBox1.Text = dr["CustomerId"].ToString();

    }
    catch { } 
}

        #region [DataSource]
        public DataTable dt;
        private DataTable GetTable()
        {
            dt = new DataTable("SourceTable");
            dt.Columns.Add(new DataColumn("CustomerId"));
            dt.Columns.Add(new DataColumn("CustomerName"));
            dt.Columns.Add(new DataColumn("CurrentCity"));
            dt.Columns.Add(new DataColumn("WorkingBranch"));

            for (int i = 0; i < 40; i++)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < dt.Columns.Count; j++)
                {
                    if (j == 0)
                        dr[j] = i + 1;
                    else
                        if (j == 1)
                        {
                            if (i % 3 == 0)
                                dr[j] = "Thomas";

                            else
                                if (i % 3 == 1)
                                    dr[j] = "Bill";
                                else if (i % 3 == 2)
                                    dr[j] = "John";
                        }
                        else
                            if (j == 2)
                            {
                                if (i % 2 == 0)
                                    dr[j] = "chicago";
                                else
                                    if (i % 3 == 0)
                                        dr[j] = "Houseton";
                                    else
                                        dr[j] = "Houseton";
                            }
                            else
                                if (j == 3)
                                {
                                    if (i % 4 == 0)
                                    {
                                        dr[j] = "Oak";

                                    }
                                    else if (i % 4 == 1)
                                    {
                                        dr[j] = "Pine";
                                    }
                                    else if (i % 4 == 2)
                                    {
                                        dr[j] = "Maple";
                                    }
                                }
                                else
                                    dr[j] = string.Format("row{0} col{1}", i, j);

                } dt.Rows.Add(dr);

            } return dt;
        }
        #endregion       
    }

}
